###################################################
### chunk number 1: 
###################################################
#line 22 "SweaveInput"
library(amei)
options(width=70, prompt="R> ", digits=5)


###################################################
### chunk number 2: 
###################################################
#line 493 "SweaveInput"
set.seed(12345)


###################################################
### chunk number 3: 
###################################################
#line 505 "SweaveInput"
tp <- list(b=0.00218, k=10, nu=0.4, mu=0) 
init <- list(S0=762, I0=1, R0=0, D0=0) 
costs <- list(vac=2, death=4, infect=1)


###################################################
### chunk number 4: 
###################################################
#line 524 "SweaveInput"
vac <- list(frac=0, stop=0)


###################################################
### chunk number 5: 
###################################################
#line 539 "SweaveInput"
init.MCepi <- MCepi(init, tp, vac, costs)


###################################################
### chunk number 6: epis
###################################################
#line 549 "SweaveInput"
plot(init.MCepi)


###################################################
### chunk number 7: costs
###################################################
#line 554 "SweaveInput"
plot(init.MCepi, type="costs")


###################################################
### chunk number 8: 
###################################################
#line 573 "SweaveInput"
vacgrid <- list(fracs=seq(0,1.0,0.1),stops=seq(2,init$S0-75,75)) 


###################################################
### chunk number 9: 
###################################################
#line 582 "SweaveInput"
out.optvac <-optvac(init, tp, vacgrid, costs) 


###################################################
### chunk number 10: 
###################################################
#line 588 "SweaveInput"
best <-getpolicy(out.optvac) 
worst <-getpolicy(out.optvac, which="worst")
rbind(best, worst)


###################################################
### chunk number 11: optvac
###################################################
#line 601 "SweaveInput"
plot(out.optvac) 


###################################################
### chunk number 12: 
###################################################
#line 621 "SweaveInput"
vac.opt <- best[3:4]
opt.MCepi <- MCepi(init, tp, vac.opt, costs)


###################################################
### chunk number 13: episov
###################################################
#line 626 "SweaveInput"
plot(opt.MCepi)


###################################################
### chunk number 14: costsov
###################################################
#line 631 "SweaveInput"
plot(opt.MCepi, type="costs")


###################################################
### chunk number 15: 
###################################################
#line 653 "SweaveInput"
getvac(opt.MCepi)


###################################################
### chunk number 16: 
###################################################
#line 666 "SweaveInput"
T <- length(opt.MCepi$Median$C)
optC <- getcost(opt.MCepi)
initC <- getcost(init.MCepi)
data.frame(rbind(initC,optC), row.names=c("init", "opt"))


###################################################
### chunk number 17: 
###################################################
#line 678 "SweaveInput"
opt.MCepi


###################################################
### chunk number 18: 
###################################################
#line 725 "SweaveInput"
out.man <- manage(init, epistep, vacgrid, costs) 


###################################################
### chunk number 19: epi
###################################################
#line 729 "SweaveInput"
plot(out.man)


###################################################
### chunk number 20: cost
###################################################
#line 734 "SweaveInput"
plot(out.man, type="cost")


###################################################
### chunk number 21: 
###################################################
#line 753 "SweaveInput"
getcost(out.man)


###################################################
### chunk number 22: params
###################################################
#line 764 "SweaveInput"
true <- as.list(formals(epistep)$true)
plot(out.man, type="params",tp=tp) 


###################################################
### chunk number 23: 
###################################################
#line 780 "SweaveInput"
out.man


###################################################
### chunk number 24: 
###################################################
#line 813 "SweaveInput"
set.seed(12345)


###################################################
### chunk number 25: 
###################################################
#line 828 "SweaveInput"
out.MCmanage <- MCmanage(init, epistep, vacgrid, costs)


###################################################
### chunk number 26: MCmanepis
###################################################
#line 840 "SweaveInput"
plot(out.MCmanage)


###################################################
### chunk number 27: MCmancosts
###################################################
#line 845 "SweaveInput"
plot(out.MCmanage, type="costs")


###################################################
### chunk number 28: 
###################################################
#line 858 "SweaveInput"
getvac(out.MCmanage)


###################################################
### chunk number 29: MCmanfracs
###################################################
#line 862 "SweaveInput"
plot(out.MCmanage, type="fracs")


###################################################
### chunk number 30: MCmanstops
###################################################
#line 867 "SweaveInput"
plot(out.MCmanage, type="stops")


###################################################
### chunk number 31: 
###################################################
#line 883 "SweaveInput"
cinit <- getcost(init.MCepi)
copt <- getcost(opt.MCepi)
cman <- getcost(out.MCmanage)
data.frame(rbind(cinit, copt, cman), 
           row.names=c("init", "opt", "man"))


###################################################
### chunk number 32: 
###################################################
#line 903 "SweaveInput"
bad <- list(b=0.001, k=10, nu=0.9, mu=0)


###################################################
### chunk number 33: 
###################################################
#line 908 "SweaveInput"
costs.bad <- optvac(init, bad, vacgrid, costs)
pol.bad <- getpolicy(costs.bad)
pol.bad


###################################################
### chunk number 34: 
###################################################
#line 916 "SweaveInput"
bad.MCepi <- MCepi(init, tp, pol.bad[3:4], costs)
cbad <- getcost(bad.MCepi)
cbad


###################################################
### chunk number 35: 
###################################################
#line 933 "SweaveInput"
set.seed(12345)


###################################################
### chunk number 36: 
###################################################
#line 994 "SweaveInput"
alt.epistep <- 
function(SIR, last=list(rem=0, rec=0, infect=0, dead=0, Z=0),
         tp=list(a = 0.05, mu = 0.05, nu = 0.1, m = 0.4, 
	 rho = 200, C = 500))
{
  ## calculate the infection probability based on the
  ## reservoir, and randomly infect susceptibles
  Z <- last$Z
  fz <- Z/(Z+tp$C)
  pi <- 1 - exp(-tp$a * fz)
  infect <- rbinom(1, SIR$S, pi)

  ## update recovereds and deaths
  pr <- 1 - exp(-tp$nu)
  rec <- rbinom(1,SIR$I,pr)
  pd <- 1 - exp(-tp$mu)
  dead <- rbinom(1, SIR$I-rec, pd)

  ## reservoir dynamics
  pz <- 1 - exp(-tp$m)
  dz <- rbinom(1, Z, pz)
  bz <- round(SIR$I*tp$rho)
  Z <- Z - dz + bz

  ## the returned list is passed in as "last" in a
  ## subsequent call to this "epistep" function
  return(list(rem=(rec+dead), rec=rec, infect=infect, 
              dead=dead, Z=Z))
}


###################################################
### chunk number 37: 
###################################################
#line 1035 "SweaveInput"
init1 <- list(S0=150, I0=1, R0=0, D0=0)
tp <- list(a=0.1, mu=0.0, nu=0.3, m=50, rho=500, C=500)
alt.epistep1 <- alt.epistep
formals(alt.epistep1)$tp <- tp
out.alt<- manage(init1, alt.epistep1, NULL, NULL, T=80)


###################################################
### chunk number 38: 
###################################################
#line 1050 "SweaveInput"
tp <- list(a=0.1, mu=0.0, nu=0.3, m=0.001, rho=500, C=500)
alt.epistep2 <- alt.epistep
formals(alt.epistep2)$tp <- tp
out.alt2 <- manage(init1, alt.epistep2, NULL, NULL, T=80)


###################################################
### chunk number 39: alt
###################################################
#line 1057 "SweaveInput"
plot(out.alt,showv=FALSE)


###################################################
### chunk number 40: alt2
###################################################
#line 1062 "SweaveInput"
plot(out.alt2,showv=FALSE)


###################################################
### chunk number 41: alt-params
###################################################
#line 1083 "SweaveInput"
plot(out.alt, type="params", showd=TRUE)


###################################################
### chunk number 42: alt2-params
###################################################
#line 1088 "SweaveInput"
plot(out.alt2, type="params", showd=TRUE)


###################################################
### chunk number 43: 
###################################################
#line 1141 "SweaveInput"
init <- list(S0=600, I0=1, R0=0, D0=0)
time <- 80
posterior <- manage(init, alt.epistep, NULL, NULL, T=time, bkrate=100)


###################################################
### chunk number 44: alt-mixing-b
###################################################
#line 1150 "SweaveInput"
plot(log(posterior$samp$b), type="l", main="",ylab=expression(b))


###################################################
### chunk number 45: alt-mixing-k
###################################################
#line 1154 "SweaveInput"
plot(posterior$samp$k, type="l", main="",ylab=expression(k))


###################################################
### chunk number 46: alt-mixing-nu
###################################################
#line 1158 "SweaveInput"
plot(posterior$samp$nu, type="l", main="",ylab=expression(nu))


###################################################
### chunk number 47: alt-mixing-mu
###################################################
#line 1162 "SweaveInput"
plot(posterior$samp$mu, type="l", main="",ylab=expression(mu))


###################################################
### chunk number 48: 
###################################################
#line 1173 "SweaveInput"
mean.params <- as.list(apply(posterior$samp, 2, mean))


###################################################
### chunk number 49: 
###################################################
#line 1179 "SweaveInput"
costs <- list(vac=2.5, death=4, infect=1) 
vacgrid <- list(fracs=seq(0,1.0,0.1), stops=seq(2,init$S0-50,50)) 
alt.optvac <- optvac(init, mean.params, vacgrid, costs, T=time)
alt.best <- getpolicy(alt.optvac)


###################################################
### chunk number 50: alt-optvac
###################################################
#line 1186 "SweaveInput"
plot(alt.optvac)


###################################################
### chunk number 51: 
###################################################
#line 1201 "SweaveInput"
alt.vac.opt <- alt.best[3:4]
alt.MCepi <- MCepi(init, alt.epistep, alt.vac.opt, costs, T=time)


###################################################
### chunk number 52: 
###################################################
#line 1205 "SweaveInput"
getcost(alt.MCepi)


###################################################
### chunk number 53: 
###################################################
#line 1213 "SweaveInput"
alt.MCmanage <- MCmanage(init, alt.epistep, vacgrid, costs, T=time)


###################################################
### chunk number 54: 
###################################################
#line 1216 "SweaveInput"
getcost(alt.MCmanage)


###################################################
### chunk number 55: alt-MCepi-t
###################################################
#line 1223 "SweaveInput"
plot(alt.MCepi, showd=TRUE)


###################################################
### chunk number 56: alt-MCepi-c
###################################################
#line 1228 "SweaveInput"
plot(alt.MCepi, type="costs")


###################################################
### chunk number 57: alt-MCmanage-t
###################################################
#line 1240 "SweaveInput"
plot(alt.MCmanage, showd=TRUE)


###################################################
### chunk number 58: alt-MCmanage-c
###################################################
#line 1245 "SweaveInput"
plot(alt.MCmanage, type="costs")


###################################################
### chunk number 59: 
###################################################
#line 1270 "SweaveInput"
alt.worst <- getpolicy(alt.optvac, which ="worst") 
rbind(alt.best, alt.worst) 


